import { PlayedWindup, PlayedWindupMember, Windup } from "./Windup";
export declare type SuffixedWindupMember<ElementType, MetadataType> = ElementType | SuffixedWindup<ElementType, MetadataType>;
export declare type SuffixedWindup<ElementType, MetadataType> = [Array<PlayedSuffixedWindupMember<ElementType, MetadataType>>, Array<SuffixedWindupMember<ElementType, MetadataType>>, Array<PlayedWindupMember<ElementType, MetadataType>>, MetadataType];
export declare type PlayedSuffixedWindupMember<ElementType, MetadataType> = ElementType | PlayedSuffixedWindup<ElementType, MetadataType>;
export declare type PlayedSuffixedWindup<ElementType, MetadataType> = [Array<PlayedSuffixedWindupMember<ElementType, MetadataType>>, Array<PlayedWindupMember<ElementType, MetadataType>>, MetadataType];
export declare function isSuffixedWindup<ElementType, MetadataType>(windup: SuffixedWindupMember<ElementType, MetadataType> | Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): windup is SuffixedWindup<ElementType, MetadataType>;
export declare function isPlayedSuffixedWindup<ElementType, MetadataType>(windup: SuffixedWindupMember<ElementType, MetadataType> | Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType> | PlayedSuffixedWindupMember<ElementType, MetadataType>): windup is PlayedSuffixedWindup<ElementType, MetadataType>;
export declare function isUnplayed<ElementType, MetadataType>(windup: SuffixedWindup<ElementType, MetadataType>): boolean;
export declare function playedSize<ElementType, MetadataType>(suffixedWindup: SuffixedWindup<ElementType, MetadataType> | PlayedSuffixedWindup<ElementType, MetadataType>): number;
export declare function playedElementsWithSuffix<ElementType, MetadataType>(windup: SuffixedWindup<ElementType, MetadataType> | PlayedSuffixedWindup<ElementType, MetadataType>): Array<PlayedSuffixedWindupMember<ElementType, MetadataType>>;
export declare function prev<ElementType, MetadataType>(suffixedWindup: SuffixedWindup<ElementType, MetadataType> | PlayedSuffixedWindup<ElementType, MetadataType>): SuffixedWindup<ElementType, MetadataType>;
export declare function next<ElementType, MetadataType>(suffixedWindup: SuffixedWindup<ElementType, MetadataType> | PlayedSuffixedWindup<ElementType, MetadataType>): SuffixedWindup<ElementType, MetadataType> | PlayedSuffixedWindup<ElementType, MetadataType>;
export declare function fastForward<E, M>(windup: SuffixedWindup<E, M> | PlayedSuffixedWindup<E, M>): PlayedSuffixedWindup<E, M>;
export declare function windupToSuffixed<E, M>(windup: Windup<E, M>): SuffixedWindup<E, M>;
export declare function playedWindupToSuffixed<E, M>(windup: PlayedWindup<E, M>): PlayedSuffixedWindup<E, M>;
export declare enum MemberKind {
    Played = 0,
    InProgress = 1
}
export declare type AnnotatedMember<E, M> = {
    member: E;
    kind: MemberKind.Played;
    isWindup: false;
} | {
    member: E;
    kind: MemberKind.InProgress;
    isWindup: false;
} | {
    member: Windup<E, M>;
    kind: MemberKind.InProgress;
    isWindup: true;
} | {
    member: PlayedWindup<E, M>;
    kind: MemberKind.Played;
    isWindup: true;
};
export declare function allMembers<E, M>(windup: Windup<E, M> | PlayedWindup<E, M>): Array<AnnotatedMember<E, M>>;
export declare function mergeWindupsToSuffixedWindup<E, M>(baseWindup: Windup<E, M> | PlayedWindup<E, M>, againstWindup: Windup<E, M> | PlayedWindup<E, M>): SuffixedWindup<E, M> | PlayedSuffixedWindup<E, M>;
export declare function getMetadata<E, M>(windup: Windup<E, M> | PlayedWindup<E, M>): M;
export declare function lastPlayedSuffixedMember<ElementType, MetadataType>(windup: SuffixedWindup<ElementType, MetadataType> | PlayedSuffixedWindup<ElementType, MetadataType>): PlayedSuffixedWindupMember<ElementType, MetadataType> | undefined;
export declare function lastPlayedSuffixedElement<ElementType, MetadataType>(windup: SuffixedWindup<ElementType, MetadataType> | PlayedSuffixedWindup<ElementType, MetadataType>): ElementType | undefined;
export declare function nextSuffixedElement<ElementType, MetadataType>(windup: SuffixedWindup<ElementType, MetadataType> | PlayedSuffixedWindup<ElementType, MetadataType>): ElementType | undefined;
export declare function unsuffixWindup<E, M>(suffixed: SuffixedWindup<E, M>): Windup<E, M>;
export declare function unsuffixPlayedWindup<E, M>(suffixed: PlayedSuffixedWindup<E, M>): PlayedWindup<E, M>;
