export declare type WindupMember<ElementType, MetadataType> = ElementType | Windup<ElementType, MetadataType>;
export declare type Windup<ElementType, MetadataType> = [Array<PlayedWindupMember<ElementType, MetadataType>>, Array<WindupMember<ElementType, MetadataType>>, MetadataType];
export declare type PlayedWindupMember<ElementType, MetadataType> = ElementType | PlayedWindup<ElementType, MetadataType>;
export declare type PlayedWindup<ElementType, MetadataType> = [Array<PlayedWindupMember<ElementType, MetadataType>>, MetadataType];
export declare function isPlayedWindup<ElementType, MetadataType>(windup: PlayedWindup<ElementType, MetadataType> | Windup<ElementType, MetadataType>): windup is PlayedWindup<ElementType, MetadataType>;
export declare function memberIsWindup<ElementType, MetadataType>(member: WindupMember<ElementType, MetadataType>): member is Windup<ElementType, MetadataType>;
export declare function playedMemberIsWindup<ElementType, MetadataType>(member: PlayedWindupMember<ElementType, MetadataType>): member is PlayedWindup<ElementType, MetadataType>;
export declare function windupFromString<MetadataType>(str: string, metadata: MetadataType): Windup<string, MetadataType>;
export declare function newWindup<ElementType, MetadataType>(arg: Array<WindupMember<ElementType, MetadataType>>, metadata: MetadataType): Windup<ElementType, MetadataType>;
export declare function isUnplayed<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): boolean;
export declare function isFinished<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): boolean;
export declare function fastForward<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): PlayedWindup<ElementType, MetadataType>;
export declare function rewind<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): Windup<ElementType, MetadataType>;
export declare function windupAsString<MetadataType>(windup: Windup<string, MetadataType> | PlayedWindup<string, MetadataType>): string;
export declare function lastPlayedMember<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): PlayedWindupMember<ElementType, MetadataType> | undefined;
export declare function lastPlayedElement<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): ElementType | undefined;
export declare function playedElements<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): Array<PlayedWindupMember<ElementType, MetadataType>>;
export declare function nextElement<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): ElementType | undefined;
export declare function prev<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>): Windup<ElementType, MetadataType>;
export declare function next<ElementType, MetadataType>(windup: Windup<ElementType, MetadataType>): Windup<ElementType, MetadataType> | PlayedWindup<ElementType, MetadataType>;
