import * as React from "react";
import { PlayedSuffixedWindup, SuffixedWindup } from "../SuffixedWindup";
import { Windup, PlayedWindup } from "../Windup";
import { SuffixedHookMetadata } from "./useRewindup";
import { HookMetadata } from "./useWindup";
declare type OnCharProps = {
    fn: (char: string, reversing?: boolean) => void;
};
declare const OnChar: React.FC<OnCharProps>;
export declare function isOnCharElement(element: React.ReactElement): element is React.ReactElement<OnCharProps>;
export declare function onCharsFromWindup<MetadataType extends HookMetadata>(windup: Windup<string, MetadataType> | PlayedWindup<string, MetadataType>): ((char: string, reversing?: boolean) => void)[];
export declare function onCharsFromSuffixedWindup<MetadataType extends SuffixedHookMetadata>(windup: SuffixedWindup<string, MetadataType> | PlayedSuffixedWindup<string, MetadataType>): ((char: string, reversing?: boolean) => void)[];
export default OnChar;
