import * as React from "react";
import { PlayedSuffixedWindup, SuffixedWindup } from "../SuffixedWindup";
import { PlayedWindup, Windup } from "../Windup";
import { SuffixedHookMetadata } from "./useRewindup";
import { HookMetadata } from "./useWindup";
declare type MsProp = {
    ms: number;
    reverseMs?: number;
};
declare type ReverseMsProp = {
    ms?: number;
    reverseMs: number;
};
declare type GetPaceProp = {
    getPace: (char: string) => number;
    getReversePace?: (char: string) => number;
};
declare type ReverseGetPaceProp = {
    getPace?: (char: string) => number;
    getReversePace: (char: string) => number;
};
declare type PaceProps = MsProp | ReverseMsProp | GetPaceProp | ReverseGetPaceProp;
export declare function defaultGetPace(lastChar: string, nextChar: string | undefined): number;
declare const Pace: React.FC<PaceProps>;
export declare function isPaceElement(element: React.ReactElement): element is React.ReactElement<PaceProps>;
export declare function isMsProp(props: PaceProps): props is MsProp;
export declare function isReverseMsProp(props: PaceProps): props is ReverseMsProp;
export declare function isReverseGetPaceProp(props: PaceProps): props is ReverseGetPaceProp;
export declare function paceMetadataFromProps(props: PaceProps): {
    pace: (char: string) => number;
    reversePace?: (char: string) => number;
} | {
    pace?: (char: string) => number;
    reversePace: (char: string) => number;
};
export declare function paceFromWindup<MetadataType extends HookMetadata>(windup: Windup<string, MetadataType> | PlayedWindup<string, MetadataType>, parentPace?: (char: string, nextChar: string | undefined) => number): ((char: string, nextChar: string | undefined) => number) | undefined;
export declare function paceFromSuffixedWindup<MetadataType extends SuffixedHookMetadata>(windup: SuffixedWindup<string, MetadataType> | PlayedSuffixedWindup<string, MetadataType>, rewinding: boolean, parentPace?: (char: string, nextChar: string | undefined) => number): ((char: string, nextChar: string | undefined) => number) | undefined;
export default Pace;
