import * as React from "react";
import { Windup, WindupMember } from "../Windup";
import { HookMetadata } from "./useWindup";
export declare const WindupContext: React.Context<{
    skip: () => void;
    rewind: () => void;
    isFinished: boolean;
}>;
export declare function useSkip(): () => void;
export declare function useRewind(): () => void;
export declare function useIsFinished(): boolean;
export interface ChildrenMetadata extends HookMetadata {
    element: React.ElementType | string | undefined;
    props?: any;
    ref?: any;
    key?: string | number | null;
}
export declare type ChildrenWindup = Windup<string, ChildrenMetadata>;
declare type ChildrenWindupMember = WindupMember<string, ChildrenMetadata>;
export declare function reduceWindupArgs(prevArgs: ChildrenWindupMember[], children: React.ReactNode): WindupMember<string, ChildrenMetadata>[];
declare type WindupChildrenProps = {
    onFinished?: () => void;
    skipped?: boolean;
};
export declare function useChildrenMemo<T>(factory: () => T, children: React.ReactNode): T;
declare const WindupChildren: React.FC<WindupChildrenProps>;
export default WindupChildren;
