import { PlayedWindup, Windup } from "../Windup";
import { PlayedSuffixedWindup, SuffixedWindup } from "../SuffixedWindup";
import { HookMetadata } from "./useWindup";
export interface SuffixedHookMetadata extends HookMetadata {
    reversePace?: (char: string, prevChar: string | undefined) => number;
}
export default function useRewindup<MetadataType extends SuffixedHookMetadata>(windupInit: Windup<string, MetadataType> | PlayedWindup<string, MetadataType>, options: {
    onFinished?: () => void;
    onRewindStart?: () => void;
}): {
    windup: SuffixedWindup<string, MetadataType> | PlayedSuffixedWindup<string, MetadataType>;
    skip: () => void;
    rewind: () => void;
    isFinished: boolean;
};
